<?php
/*
+--------------------------------------------------------------------------
|   Alex News Engine
|   ========================================
|   by Alex Hntschel
|   (c) 2002 AlexScriptEngine
|   http://www.alexscriptengine.de
|   ========================================
|   Web: http://www.alexscriptengine.de
|   Email: info@alexscriptengine.de
+---------------------------------------------------------------------------
|
|   > Beschreibung
|   > Klasse fr die Formatierung der Kommentare und der News
|
+--------------------------------------------------------------------------
*/

class sBBcode{
  var $replace = array();
  var $search = array();
  var $smilies = array();
  var $lock_chars = "([^\"'\(\)\%\;\=]*)";
  var $normal_chars = '(.*)';
  var $imgcode = 0;
  
  // Ausgabe der BB-Codes in der Var $text
  function parsen($text){
    $text = preg_replace($this->search,$this->replace,$text);
    return $text;
  }

  // hier wird die Datei mit den BB-Codes geladen
  function get_file($file){
    if(!@include($file)){
      die('Source file Error');
    }
    return;
  }
  
  function new_tag($search,$replace,$params = 0,$ende = 0,$interlace = 0,$secure = 0,$php = 0,$pparser = 0){
    if($pparser == 1){
      $replace = $this->param_parser($replace,$params);
    }

    if($php == 1){
      $options = 'miUse';
    }else{
      $options = 'miUs';
    }
  
    if($secure == 1){
      $chars = $this->lock_chars;
    }else{
      $chars = $this->normal_chars;
    }
  
    if($params == 0){
      $rex = "\[$search]";
    }else{
      $prex = $this->lock_chars;
      $i = 1;
      while($params > $i){
        $prex .= ",$this->lock_chars";
        ++$i;
      }
      $rex = "\[$search=(([\"\']?)$prex)\\2]";
    }
    
    if($ende == 1){
      $rex = "/$rex$chars\[\/$search\]/$options";
    }else{
     $rex = "/$rex/$options";
    }

    $i = -1;
    while($interlace > $i){
      $this->search[] = $rex;
      $this->replace[] = $replace;
      ++$i;
    }
    return;
  }
  
  // mit dieser Funktion werden eingegebene Urls oder Email-Adressen direkt in Links umgesetzt, auch ohne BB-Code
  function url_parse($text){
    $urlsearch[]="/([^]_a-z0-9-=\"'\/])((https?|ftp):\/\/|www\.)([^ \r\n\(\)\*\^\$!`\"'\|\[\]\{\};<>]*)/si";
    $urlsearch[]="/^((https?|ftp):\/\/|www\.)([^ \r\n\(\)\*\^\$!`\"'\|\[\]\{\};<>]*)/si";
    $urlreplace[]="\\1[URL]\\2\\4[/URL]";
    $urlreplace[]="[URL]\\1\\3[/URL]";
    $emailsearch[]="/([\s])([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si";
    $emailsearch[]="/^([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si";
    $emailreplace[]="\\1[EMAIL]\\2[/EMAIL]";
    $emailreplace[]="[EMAIL]\\0[/EMAIL]";
    $text = preg_replace($urlsearch, $urlreplace, $text);
    if (strpos($text, "@")) $text = preg_replace($emailsearch, $emailreplace, $text);
    
	#$text = preg_replace(array("/(^[_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@([a-zA-Z0-9-]+\.)+([a-zA-Z]{2,4})$)/","/(www\.([a-zA-Z0-9_\-.\/]{2,}))/","/((([a-zA-Z]{2,6}):\/\/)+([a-zA-Z0-9_\-.\/]{2,}))/"),array("[email]\\1[/email]","http://\\1","[url]\\1[/url]"),$text);
    return $text;
  }
  
  // hier werden Listen erstellt
  function listcode($text,$type = ""){
    if($type != ""){
      $type = $type;
    }else{
      $type = "ul";
    }
    
    $text = str_replace('[*]','<li>',$text);
    $text = "<$type>$text</li></$type>";
    return $text;
  }
 
 
  // hier wird PHP-Code dargestellt 
  function phpcode($text){
    $text = stripslashes($text);
    $text = str_replace("&lt;","<",$text);
    $text = str_replace("&gt;",">",$text);
    $text = str_replace("&quot;","\"",$text);
    $text = str_replace("&amp;","&",$text);
    ob_start();
    
    if(!strstr($text,'<?')){
      highlight_string("<?php $text");
    }else{
      highlight_string($text);
    }
    
    $text = ob_get_contents();
    $text = "<blockquote><font size=2>PHP:<hr>$text</font><hr></blockquote>";
    ob_end_clean();
    return $text;
  }
  
  // hier wird SQL-Code ausgefiltert
  function sqlcode($text){
    $text = preg_replace(array("/(=|\+|\-|&gt;|&lt;|~|==|\!=|LIKE|NOT LIKE|REGEXP)/i","/(MAX|AVG|SUM|COUNT|MIN)\(/i","/(&quot;|&#39;|&#039;)(.+?)(&quot;|&#39;|&#039;)/i","/\s{1,}(AND|OR)\s{1,}/i","/LIMIT\s*(\d+)\s*,\s*(\d+)/i","/(FROM|INTO)\s{1,}(\S+?)\s{1,}/i","/((LEFT|RIGHT|NATURAL|STRAIGT)+(\s|\sINNER\s|\sOUTER\s)+JOIN)\s{1,}(\S+?)\s{1,}/i","/(WHERE|MODIFY|CHANGE|AS|DISTINCT|IN|ASC|DESC|ORDER BY)\s{1,}/i","/(SELECT|INSERT|UPDATE|DELETE|ALTER TABLE|DROP)/i"),array("<span style='color:orange'>\\1</span>","<span style='color:blue'>\\1</span>(","<span style='color:red'>\\1\\2\\3</span>","<span style='color:blue'>\\1</span> "," <span style='color:green'>\\1</span> ","<span style='color:green'>\\1</span> <span style='color:orange'>\\2</span> ","<span style='color:green'>\\1</span> <span style='color:orange'>\\4</span> ","<span style='color:green'>LIMIT</span> <span style='color:orange'>\\1, \\2</span>","<span style='color:blue;font-weight:bold'>\\1</span>"),stripslashes($text));
    $text = "<blockquote><font size=2>SQL:</font><hr><font size=2>$text</font><hr></blockquote>";
    return $text;
  }
 
  function param_parser($text,$parameter){
    if($parameter > 0){
      $param = 3;
    }else{
      $param = 1;
    }

    $p = $parameter+1;
    $id = 0;
    $string = str_replace('{text}',"\\\\$p",$string);
    while($parameter > $id){
      $text = str_replace("{param$id}","\\\\$param",$text);
      ++$param;
      ++$id;
    }
    return $text;
  }
  
  // Ende der Klassendeklaration
}

?>
